diff --git a/sys/dev/misc/psm/psm.c b/sys/dev/misc/psm/psm.c
index 4a6ede1..d7a8535 100644
--- a/sys/dev/misc/psm/psm.c
+++ b/sys/dev/misc/psm/psm.c
@@ -2492,381 +3609,1110 @@ enable_lcordless(struct psm_softc *sc)
 static int
 enable_groller(struct psm_softc *sc)
 {
-    int status[3];
-
-    /*
-     * The special sequence to enable the fourth button and the
-     * roller. Immediately after this sequence check status bytes.
-     * if the mouse is NetScroll, the second and the third bytes are 
-     * '3' and 'D'.
-     */
-
-    /*
-     * If the mouse is an ordinary PS/2 mouse, the status bytes should
-     * look like the following.
-     * 
-     * byte 1 bit 7 always 0
-     *        bit 6 stream mode (0)
-     *        bit 5 disabled (0)
-     *        bit 4 1:1 scaling (0)
-     *        bit 3 always 0
-     *        bit 0-2 button status
-     * byte 2 resolution (PSMD_RES_HIGH)
-     * byte 3 report rate (?)
-     */
-
-    if (!mouse_id_proc1(sc->kbdc, PSMD_RES_HIGH, 1, status))
-        return FALSE;
-    if ((status[1] != '3') || (status[2] != 'D'))
-        return FALSE;
-    /* FIXME: SmartScroll Mouse has 5 buttons! XXX */
-    sc->hw.buttons = 4;
-    return TRUE;
+	int status[3];
+
+	/*
+	 * The special sequence to enable the fourth button and the
+	 * roller. Immediately after this sequence check status bytes.
+	 * if the mouse is NetScroll, the second and the third bytes are
+	 * '3' and 'D'.
+	 */
+
+	/*
+	 * If the mouse is an ordinary PS/2 mouse, the status bytes should
+	 * look like the following.
+	 *
+	 * byte 1 bit 7 always 0
+	 *        bit 6 stream mode (0)
+	 *        bit 5 disabled (0)
+	 *        bit 4 1:1 scaling (0)
+	 *        bit 3 always 0
+	 *        bit 0-2 button status
+	 * byte 2 resolution (PSMD_RES_HIGH)
+	 * byte 3 report rate (?)
+	 */
+
+	if (!mouse_id_proc1(sc->kbdc, PSMD_RES_HIGH, 1, status))
+		return (FALSE);
+	if ((status[1] != '3') || (status[2] != 'D'))
+		return (FALSE);
+	/* FIXME: SmartScroll Mouse has 5 buttons! XXX */
+	sc->hw.buttons = 4;
+	return (TRUE);
 }
 
 /* Genius NetMouse/NetMouse Pro, ASCII Mie Mouse, NetScroll Optical */
 static int
 enable_gmouse(struct psm_softc *sc)
 {
-    int status[3];
-
-    /*
-     * The special sequence to enable the middle, "rubber" button. 
-     * Immediately after this sequence check status bytes.
-     * if the mouse is NetMouse, NetMouse Pro, or ASCII MIE Mouse, 
-     * the second and the third bytes are '3' and 'U'.
-     * NOTE: NetMouse reports that it has three buttons although it has
-     * two buttons and a rubber button. NetMouse Pro and MIE Mouse
-     * say they have three buttons too and they do have a button on the
-     * side...
-     */
-    if (!mouse_id_proc1(sc->kbdc, PSMD_RES_HIGH, 1, status))
-        return FALSE;
-    if ((status[1] != '3') || (status[2] != 'U'))
-        return FALSE;
-    return TRUE;
+	int status[3];
+
+	/*
+	 * The special sequence to enable the middle, "rubber" button.
+	 * Immediately after this sequence check status bytes.
+	 * if the mouse is NetMouse, NetMouse Pro, or ASCII MIE Mouse,
+	 * the second and the third bytes are '3' and 'U'.
+	 * NOTE: NetMouse reports that it has three buttons although it has
+	 * two buttons and a rubber button. NetMouse Pro and MIE Mouse
+	 * say they have three buttons too and they do have a button on the
+	 * side...
+	 */
+	if (!mouse_id_proc1(sc->kbdc, PSMD_RES_HIGH, 1, status))
+		return (FALSE);
+	if ((status[1] != '3') || (status[2] != 'U'))
+		return (FALSE);
+	return (TRUE);
 }
 
 /* ALPS GlidePoint */
 static int
 enable_aglide(struct psm_softc *sc)
 {
-    int status[3];
-
-    /*
-     * The special sequence to obtain ALPS GlidePoint specific
-     * information. Immediately after this sequence, status bytes will 
-     * contain something interesting.
-     * NOTE: ALPS produces several models of GlidePoint. Some of those
-     * do not respond to this sequence, thus, cannot be detected this way.
-     */
-    if (set_mouse_sampling_rate(sc->kbdc, 100) != 100)
-	return FALSE;
-    if (!mouse_id_proc1(sc->kbdc, PSMD_RES_LOW, 2, status))
-        return FALSE;
-    if ((status[1] == PSMD_RES_LOW) || (status[2] == 100))
-        return FALSE;
-    return TRUE;
+	int status[3];
+
+	/*
+	 * The special sequence to obtain ALPS GlidePoint specific
+	 * information. Immediately after this sequence, status bytes will
+	 * contain something interesting.
+	 * NOTE: ALPS produces several models of GlidePoint. Some of those
+	 * do not respond to this sequence, thus, cannot be detected this way.
+	 */
+	if (set_mouse_sampling_rate(sc->kbdc, 100) != 100)
+		return (FALSE);
+	if (!mouse_id_proc1(sc->kbdc, PSMD_RES_LOW, 2, status))
+		return (FALSE);
+	if ((status[1] == PSMD_RES_LOW) || (status[2] == 100))
+		return (FALSE);
+	return (TRUE);
 }
 
 /* Kensington ThinkingMouse/Trackball */
 static int
 enable_kmouse(struct psm_softc *sc)
 {
-    static unsigned char rate[] = { 20, 60, 40, 20, 20, 60, 40, 20, 20 };
-    KBDC kbdc = sc->kbdc;
-    int status[3];
-    int id1;
-    int id2;
-    int i;
-
-    id1 = get_aux_id(kbdc);
-    if (set_mouse_sampling_rate(kbdc, 10) != 10)
-	return FALSE;
-    /* 
-     * The device is now in the native mode? It returns a different
-     * ID value...
-     */
-    id2 = get_aux_id(kbdc);
-    if ((id1 == id2) || (id2 != 2))
-	return FALSE;
-
-    if (set_mouse_resolution(kbdc, PSMD_RES_LOW) != PSMD_RES_LOW)
-        return FALSE;
+	static u_char rate[] = { 20, 60, 40, 20, 20, 60, 40, 20, 20 };
+	KBDC kbdc = sc->kbdc;
+	int status[3];
+	int id1;
+	int id2;
+	int i;
+
+	id1 = get_aux_id(kbdc);
+	if (set_mouse_sampling_rate(kbdc, 10) != 10)
+		return (FALSE);
+	/*
+	 * The device is now in the native mode? It returns a different
+	 * ID value...
+	 */
+	id2 = get_aux_id(kbdc);
+	if ((id1 == id2) || (id2 != 2))
+		return (FALSE);
+
+	if (set_mouse_resolution(kbdc, PSMD_RES_LOW) != PSMD_RES_LOW)
+		return (FALSE);
 #if PSM_DEBUG >= 2
-    /* at this point, resolution is LOW, sampling rate is 10/sec */
-    if (get_mouse_status(kbdc, status, 0, 3) < 3)
-        return FALSE;
+	/* at this point, resolution is LOW, sampling rate is 10/sec */
+	if (get_mouse_status(kbdc, status, 0, 3) < 3)
+		return (FALSE);
 #endif
 
-    /*
-     * The special sequence to enable the third and fourth buttons.
-     * Otherwise they behave like the first and second buttons.
-     */
-    for (i = 0; i < sizeof(rate)/sizeof(rate[0]); ++i) {
-        if (set_mouse_sampling_rate(kbdc, rate[i]) != rate[i])
-	    return FALSE;
-    }
-
-    /* 
-     * At this point, the device is using default resolution and
-     * sampling rate for the native mode. 
-     */
-    if (get_mouse_status(kbdc, status, 0, 3) < 3)
-        return FALSE;
-    if ((status[1] == PSMD_RES_LOW) || (status[2] == rate[i - 1]))
-        return FALSE;
-
-    /* the device appears be enabled by this sequence, diable it for now */
-    disable_aux_dev(kbdc);
-    empty_aux_buffer(kbdc, 5);
-
-    return TRUE;
+	/*
+	 * The special sequence to enable the third and fourth buttons.
+	 * Otherwise they behave like the first and second buttons.
+	 */
+	for (i = 0; i < sizeof(rate)/sizeof(rate[0]); ++i)
+		if (set_mouse_sampling_rate(kbdc, rate[i]) != rate[i])
+			return (FALSE);
+
+	/*
+	 * At this point, the device is using default resolution and
+	 * sampling rate for the native mode.
+	 */
+	if (get_mouse_status(kbdc, status, 0, 3) < 3)
+		return (FALSE);
+	if ((status[1] == PSMD_RES_LOW) || (status[2] == rate[i - 1]))
+		return (FALSE);
+
+	/* the device appears be enabled by this sequence, diable it for now */
+	disable_aux_dev(kbdc);
+	empty_aux_buffer(kbdc, 5);
+
+	return (TRUE);
 }
 
 /* Logitech MouseMan+/FirstMouse+, IBM ScrollPoint Mouse */
 static int
 enable_mmanplus(struct psm_softc *sc)
 {
-    KBDC kbdc = sc->kbdc;
-    int data[3];
-
-    /* the special sequence to enable the fourth button and the roller. */
-    /*
-     * NOTE: for ScrollPoint to respond correctly, the SET_RESOLUTION
-     * must be called exactly three times since the last RESET command
-     * before this sequence. XXX
-     */
-    if (!set_mouse_scaling(kbdc, 1))
-	return FALSE;
-    if (!mouse_ext_command(kbdc, 0x39) || !mouse_ext_command(kbdc, 0xdb))
-	return FALSE;
-    if (get_mouse_status(kbdc, data, 1, 3) < 3)
-        return FALSE;
-
-    /*
-     * PS2++ protocl, packet type 0
-     *
-     *          b7 b6 b5 b4 b3 b2 b1 b0
-     * byte 1:  *  1  p3 p2 1  *  *  *
-     * byte 2:  1  1  p1 p0 m1 m0 1  0
-     * byte 3:  m7 m6 m5 m4 m3 m2 m1 m0
-     *
-     * p3-p0: packet type: 0
-     * m7-m0: model ID: MouseMan+:0x50, FirstMouse+:0x51, ScrollPoint:0x58...
-     */
-    /* check constant bits */
-    if ((data[0] & MOUSE_PS2PLUS_SYNCMASK) != MOUSE_PS2PLUS_SYNC)
-        return FALSE;
-    if ((data[1] & 0xc3) != 0xc2)
-        return FALSE;
-    /* check d3-d0 in byte 2 */
-    if (!MOUSE_PS2PLUS_CHECKBITS(data))
-        return FALSE;
-    /* check p3-p0 */
-    if (MOUSE_PS2PLUS_PACKET_TYPE(data) != 0)
-        return FALSE;
-
-    sc->hw.hwid &= 0x00ff;
-    sc->hw.hwid |= data[2] << 8;	/* save model ID */
-
-    /*
-     * MouseMan+ (or FirstMouse+) is now in its native mode, in which
-     * the wheel and the fourth button events are encoded in the
-     * special data packet. The mouse may be put in the IntelliMouse mode
-     * if it is initialized by the IntelliMouse's method.
-     */
-    return TRUE;
+	KBDC kbdc = sc->kbdc;
+	int data[3];
+
+	/* the special sequence to enable the fourth button and the roller. */
+	/*
+	 * NOTE: for ScrollPoint to respond correctly, the SET_RESOLUTION
+	 * must be called exactly three times since the last RESET command
+	 * before this sequence. XXX
+	 */
+	if (!set_mouse_scaling(kbdc, 1))
+		return (FALSE);
+	if (!mouse_ext_command(kbdc, 0x39) || !mouse_ext_command(kbdc, 0xdb))
+		return (FALSE);
+	if (get_mouse_status(kbdc, data, 1, 3) < 3)
+		return (FALSE);
+
+	/*
+	 * PS2++ protocl, packet type 0
+	 *
+	 *          b7 b6 b5 b4 b3 b2 b1 b0
+	 * byte 1:  *  1  p3 p2 1  *  *  *
+	 * byte 2:  1  1  p1 p0 m1 m0 1  0
+	 * byte 3:  m7 m6 m5 m4 m3 m2 m1 m0
+	 *
+	 * p3-p0: packet type: 0
+	 * m7-m0: model ID: MouseMan+:0x50,
+	 *		    FirstMouse+:0x51,
+	 *		    ScrollPoint:0x58...
+	 */
+	/* check constant bits */
+	if ((data[0] & MOUSE_PS2PLUS_SYNCMASK) != MOUSE_PS2PLUS_SYNC)
+		return (FALSE);
+	if ((data[1] & 0xc3) != 0xc2)
+		return (FALSE);
+	/* check d3-d0 in byte 2 */
+	if (!MOUSE_PS2PLUS_CHECKBITS(data))
+		return (FALSE);
+	/* check p3-p0 */
+	if (MOUSE_PS2PLUS_PACKET_TYPE(data) != 0)
+		return (FALSE);
+
+	sc->hw.hwid &= 0x00ff;
+	sc->hw.hwid |= data[2] << 8;	/* save model ID */
+
+	/*
+	 * MouseMan+ (or FirstMouse+) is now in its native mode, in which
+	 * the wheel and the fourth button events are encoded in the
+	 * special data packet. The mouse may be put in the IntelliMouse mode
+	 * if it is initialized by the IntelliMouse's method.
+	 */
+	return (TRUE);
 }
 
 /* MS IntelliMouse Explorer */
 static int
 enable_msexplorer(struct psm_softc *sc)
 {
-    static unsigned char rate0[] = { 200, 100, 80, };
-    static unsigned char rate1[] = { 200, 200, 80, };
-    KBDC kbdc = sc->kbdc;
-    int id;
-    int i;
-
-    /* the special sequence to enable the extra buttons and the roller. */
-    for (i = 0; i < sizeof(rate1)/sizeof(rate1[0]); ++i) {
-        if (set_mouse_sampling_rate(kbdc, rate1[i]) != rate1[i])
-	    return FALSE;
-    }
-    /* the device will give the genuine ID only after the above sequence */
-    id = get_aux_id(kbdc);
-    if (id != PSM_EXPLORER_ID)
-	return FALSE;
-
-    sc->hw.hwid = id;
-    sc->hw.buttons = 5;		/* IntelliMouse Explorer XXX */
-
-    /*
-     * XXX: this is a kludge to fool some KVM switch products
-     * which think they are clever enough to know the 4-byte IntelliMouse
-     * protocol, and assume any other protocols use 3-byte packets.
-     * They don't convey 4-byte data packets from the IntelliMouse Explorer 
-     * correctly to the host computer because of this!
-     * The following sequence is actually IntelliMouse's "wake up"
-     * sequence; it will make the KVM think the mouse is IntelliMouse
-     * when it is in fact IntelliMouse Explorer.
-     */
-    for (i = 0; i < sizeof(rate0)/sizeof(rate0[0]); ++i) {
-        if (set_mouse_sampling_rate(kbdc, rate0[i]) != rate0[i])
-	    break;
-    }
-    id = get_aux_id(kbdc);
-
-    return TRUE;
+	static u_char rate0[] = { 200, 100, 80, };
+	static u_char rate1[] = { 200, 200, 80, };
+	KBDC kbdc = sc->kbdc;
+	int id;
+	int i;
+
+	/*
+	 * This is needed for at least A4Tech X-7xx mice - they do not go
+	 * straight to Explorer mode, but need to be set to Intelli mode
+	 * first.
+	 */
+	enable_msintelli(sc);
+
+	/* the special sequence to enable the extra buttons and the roller. */
+	for (i = 0; i < sizeof(rate1)/sizeof(rate1[0]); ++i)
+		if (set_mouse_sampling_rate(kbdc, rate1[i]) != rate1[i])
+			return (FALSE);
+	/* the device will give the genuine ID only after the above sequence */
+	id = get_aux_id(kbdc);
+	if (id != PSM_EXPLORER_ID)
+		return (FALSE);
+
+	sc->hw.hwid = id;
+	sc->hw.buttons = 5;		/* IntelliMouse Explorer XXX */
+
+	/*
+	 * XXX: this is a kludge to fool some KVM switch products
+	 * which think they are clever enough to know the 4-byte IntelliMouse
+	 * protocol, and assume any other protocols use 3-byte packets.
+	 * They don't convey 4-byte data packets from the IntelliMouse Explorer
+	 * correctly to the host computer because of this!
+	 * The following sequence is actually IntelliMouse's "wake up"
+	 * sequence; it will make the KVM think the mouse is IntelliMouse
+	 * when it is in fact IntelliMouse Explorer.
+	 */
+	for (i = 0; i < sizeof(rate0)/sizeof(rate0[0]); ++i)
+		if (set_mouse_sampling_rate(kbdc, rate0[i]) != rate0[i])
+			break;
+	id = get_aux_id(kbdc);
+
+	return (TRUE);
 }
 
 /* MS IntelliMouse */
 static int
 enable_msintelli(struct psm_softc *sc)
 {
-    /*
-     * Logitech MouseMan+ and FirstMouse+ will also respond to this
-     * probe routine and act like IntelliMouse.
-     */
-
-    static unsigned char rate[] = { 200, 100, 80, };
-    KBDC kbdc = sc->kbdc;
-    int id;
-    int i;
-
-    /* the special sequence to enable the third button and the roller. */
-    for (i = 0; i < sizeof(rate)/sizeof(rate[0]); ++i) {
-        if (set_mouse_sampling_rate(kbdc, rate[i]) != rate[i])
-	    return FALSE;
-    }
-    /* the device will give the genuine ID only after the above sequence */
-    id = get_aux_id(kbdc);
-    if (id != PSM_INTELLI_ID)
-	return FALSE;
-
-    sc->hw.hwid = id;
-    sc->hw.buttons = 3;
-
-    return TRUE;
+	/*
+	 * Logitech MouseMan+ and FirstMouse+ will also respond to this
+	 * probe routine and act like IntelliMouse.
+	 */
+
+	static u_char rate[] = { 200, 100, 80, };
+	KBDC kbdc = sc->kbdc;
+	int id;
+	int i;
+
+	/* the special sequence to enable the third button and the roller. */
+	for (i = 0; i < sizeof(rate)/sizeof(rate[0]); ++i)
+		if (set_mouse_sampling_rate(kbdc, rate[i]) != rate[i])
+			return (FALSE);
+	/* the device will give the genuine ID only after the above sequence */
+	id = get_aux_id(kbdc);
+	if (id != PSM_INTELLI_ID)
+		return (FALSE);
+
+	sc->hw.hwid = id;
+	sc->hw.buttons = 3;
+
+	return (TRUE);
 }
 
 /* A4 Tech 4D Mouse */
 static int
 enable_4dmouse(struct psm_softc *sc)
 {
-    /*
-     * Newer wheel mice from A4 Tech may use the 4D+ protocol.
-     */
-
-    static unsigned char rate[] = { 200, 100, 80, 60, 40, 20 };
-    KBDC kbdc = sc->kbdc;
-    int id;
-    int i;
-
-    for (i = 0; i < sizeof(rate)/sizeof(rate[0]); ++i) {
-        if (set_mouse_sampling_rate(kbdc, rate[i]) != rate[i])
-	    return FALSE;
-    }
-    id = get_aux_id(kbdc);
-    /*
-     * WinEasy 4D, 4 Way Scroll 4D: 6
-     * Cable-Free 4D: 8 (4DPLUS)
-     * WinBest 4D+, 4 Way Scroll 4D+: 8 (4DPLUS)
-     */
-    if (id != PSM_4DMOUSE_ID)
-	return FALSE;
-
-    sc->hw.hwid = id;
-    sc->hw.buttons = 3;		/* XXX some 4D mice have 4? */
-
-    return TRUE;
+	/*
+	 * Newer wheel mice from A4 Tech may use the 4D+ protocol.
+	 */
+
+	static u_char rate[] = { 200, 100, 80, 60, 40, 20 };
+	KBDC kbdc = sc->kbdc;
+	int id;
+	int i;
+
+	for (i = 0; i < sizeof(rate)/sizeof(rate[0]); ++i)
+		if (set_mouse_sampling_rate(kbdc, rate[i]) != rate[i])
+			return (FALSE);
+	id = get_aux_id(kbdc);
+	/*
+	 * WinEasy 4D, 4 Way Scroll 4D: 6
+	 * Cable-Free 4D: 8 (4DPLUS)
+	 * WinBest 4D+, 4 Way Scroll 4D+: 8 (4DPLUS)
+	 */
+	if (id != PSM_4DMOUSE_ID)
+		return (FALSE);
+
+	sc->hw.hwid = id;
+	sc->hw.buttons = 3;		/* XXX some 4D mice have 4? */
+
+	return (TRUE);
 }
 
 /* A4 Tech 4D+ Mouse */
 static int
 enable_4dplus(struct psm_softc *sc)
 {
-    /*
-     * Newer wheel mice from A4 Tech seem to use this protocol.
-     * Older models are recognized as either 4D Mouse or IntelliMouse.
-     */
-    KBDC kbdc = sc->kbdc;
-    int id;
-
-    /*
-     * enable_4dmouse() already issued the following ID sequence...
-    static unsigned char rate[] = { 200, 100, 80, 60, 40, 20 };
-    int i;
-
-    for (i = 0; i < sizeof(rate)/sizeof(rate[0]); ++i) {
-        if (set_mouse_sampling_rate(kbdc, rate[i]) != rate[i])
-	    return FALSE;
-    }
-    */
-
-    id = get_aux_id(kbdc);
-    if (id != PSM_4DPLUS_ID)
-	return FALSE;
-
-    sc->hw.hwid = id;
-    sc->hw.buttons = 4;		/* XXX */
-
-    return TRUE;
+	/*
+	 * Newer wheel mice from A4 Tech seem to use this protocol.
+	 * Older models are recognized as either 4D Mouse or IntelliMouse.
+	 */
+	KBDC kbdc = sc->kbdc;
+	int id;
+
+	/*
+	 * enable_4dmouse() already issued the following ID sequence...
+	static u_char rate[] = { 200, 100, 80, 60, 40, 20 };
+	int i;
+
+	for (i = 0; i < sizeof(rate)/sizeof(rate[0]); ++i)
+		if (set_mouse_sampling_rate(kbdc, rate[i]) != rate[i])
+			return (FALSE);
+	*/
+
+	id = get_aux_id(kbdc);
+	switch (id) {
+	case PSM_4DPLUS_ID:
+		sc->hw.buttons = 4;
+		break;
+	case PSM_4DPLUS_RFSW35_ID:
+		sc->hw.buttons = 3;
+		break;
+	default:
+		return (FALSE);
+	}
+
+	sc->hw.hwid = id;
+
+	return (TRUE);
+}
+
+/* Synaptics Touchpad */
+static int
+synaptics_sysctl(SYSCTL_HANDLER_ARGS)
+{
+	int error, arg;
+
+	/* Read the current value. */
+	arg = *(int *)oidp->oid_arg1;
+	error = sysctl_handle_int(oidp, &arg, 0, req);
+
+	/* Sanity check. */
+	if (error || !req->newptr)
+		return (error);
+
+	/*
+	 * Check that the new value is in the concerned node's range
+	 * of values.
+	 */
+	switch (oidp->oid_arg2) {
+	case SYNAPTICS_SYSCTL_MIN_PRESSURE:
+	case SYNAPTICS_SYSCTL_MAX_PRESSURE:
+		if (arg < 0 || arg > 255)
+			return (EINVAL);
+		break;
+	case SYNAPTICS_SYSCTL_MAX_WIDTH:
+		if (arg < 4 || arg > 15)
+			return (EINVAL);
+		break;
+	case SYNAPTICS_SYSCTL_MARGIN_TOP:
+	case SYNAPTICS_SYSCTL_MARGIN_RIGHT:
+	case SYNAPTICS_SYSCTL_MARGIN_BOTTOM:
+	case SYNAPTICS_SYSCTL_MARGIN_LEFT:
+	case SYNAPTICS_SYSCTL_NA_TOP:
+	case SYNAPTICS_SYSCTL_NA_RIGHT:
+	case SYNAPTICS_SYSCTL_NA_BOTTOM:
+	case SYNAPTICS_SYSCTL_NA_LEFT:
+		if (arg < 0 || arg > 6143)
+			return (EINVAL);
+		break;
+	case SYNAPTICS_SYSCTL_WINDOW_MIN:
+	case SYNAPTICS_SYSCTL_WINDOW_MAX:
+	case SYNAPTICS_SYSCTL_TAP_MIN_QUEUE:
+		if (arg < 1 || arg > SYNAPTICS_PACKETQUEUE)
+			return (EINVAL);
+		break;
+	case SYNAPTICS_SYSCTL_MULTIPLICATOR:
+	case SYNAPTICS_SYSCTL_WEIGHT_CURRENT:
+	case SYNAPTICS_SYSCTL_WEIGHT_PREVIOUS:
+	case SYNAPTICS_SYSCTL_WEIGHT_PREVIOUS_NA:
+	case SYNAPTICS_SYSCTL_WEIGHT_LEN_SQUARED:
+	case SYNAPTICS_SYSCTL_DIV_MIN:
+	case SYNAPTICS_SYSCTL_DIV_MAX:
+	case SYNAPTICS_SYSCTL_DIV_MAX_NA:
+	case SYNAPTICS_SYSCTL_DIV_LEN:
+	case SYNAPTICS_SYSCTL_VSCROLL_DIV_MIN:
+	case SYNAPTICS_SYSCTL_VSCROLL_DIV_MAX:
+		if (arg < 1)
+			return (EINVAL);
+		break;
+	case SYNAPTICS_SYSCTL_TAP_MAX_DELTA:
+	case SYNAPTICS_SYSCTL_TAPHOLD_TIMEOUT:
+	case SYNAPTICS_SYSCTL_VSCROLL_MIN_DELTA:
+		if (arg < 0)
+			return (EINVAL);
+		break;
+	case SYNAPTICS_SYSCTL_VSCROLL_HOR_AREA:
+	case SYNAPTICS_SYSCTL_VSCROLL_VER_AREA:
+		if (arg < -6143 || arg > 6143)
+			return (EINVAL);
+		break;
+	default:
+		return (EINVAL);
+	}
+
+	/* Update. */
+	*(int *)oidp->oid_arg1 = arg;
+
+	return (error);
+}
+
+static void
+synaptics_sysctl_create_tree(struct psm_softc *sc)
+{
+
+	if (sc->syninfo.sysctl_tree != NULL)
+		return;
+
+	/* Attach extra synaptics sysctl nodes under hw.psm.synaptics */
+	sysctl_ctx_init(&sc->syninfo.sysctl_ctx);
+	sc->syninfo.sysctl_tree = SYSCTL_ADD_NODE(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_STATIC_CHILDREN(_hw_psm), OID_AUTO, "synaptics", CTLFLAG_RD,
+	    0, "Synaptics TouchPad");
+
+	/* hw.psm.synaptics.directional_scrolls. */
+	sc->syninfo.directional_scrolls = 1;
+	SYSCTL_ADD_INT(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "directional_scrolls", CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.directional_scrolls, 0,
+	    "Enable hardware scrolling pad (if non-zero) or register it as "
+	    "a middle-click (if 0)");
+
+	/* hw.psm.synaptics.min_pressure. */
+	sc->syninfo.min_pressure = 16;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "min_pressure", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.min_pressure, SYNAPTICS_SYSCTL_MIN_PRESSURE,
+	    synaptics_sysctl, "I",
+	    "Minimum pressure required to start an action");
+
+	/* hw.psm.synaptics.max_pressure. */
+	sc->syninfo.max_pressure = 220;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "max_pressure", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.max_pressure, SYNAPTICS_SYSCTL_MAX_PRESSURE,
+	    synaptics_sysctl, "I",
+	    "Maximum pressure to detect palm");
+
+	/* hw.psm.synaptics.max_width. */
+	sc->syninfo.max_width = 10;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "max_width", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.max_width, SYNAPTICS_SYSCTL_MAX_WIDTH,
+	    synaptics_sysctl, "I",
+	    "Maximum finger width to detect palm");
+
+	/* hw.psm.synaptics.top_margin. */
+	sc->syninfo.margin_top = 200;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "margin_top", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.margin_top, SYNAPTICS_SYSCTL_MARGIN_TOP,
+	    synaptics_sysctl, "I",
+	    "Top margin");
+
+	/* hw.psm.synaptics.right_margin. */
+	sc->syninfo.margin_right = 200;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "margin_right", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.margin_right, SYNAPTICS_SYSCTL_MARGIN_RIGHT,
+	    synaptics_sysctl, "I",
+	    "Right margin");
+
+	/* hw.psm.synaptics.bottom_margin. */
+	sc->syninfo.margin_bottom = 200;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "margin_bottom", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.margin_bottom, SYNAPTICS_SYSCTL_MARGIN_BOTTOM,
+	    synaptics_sysctl, "I",
+	    "Bottom margin");
+
+	/* hw.psm.synaptics.left_margin. */
+	sc->syninfo.margin_left = 200;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "margin_left", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.margin_left, SYNAPTICS_SYSCTL_MARGIN_LEFT,
+	    synaptics_sysctl, "I",
+	    "Left margin");
+
+	/* hw.psm.synaptics.na_top. */
+	sc->syninfo.na_top = 1783;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "na_top", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.na_top, SYNAPTICS_SYSCTL_NA_TOP,
+	    synaptics_sysctl, "I",
+	    "Top noisy area, where weight_previous_na is used instead "
+	    "of weight_previous");
+
+	/* hw.psm.synaptics.na_right. */
+	sc->syninfo.na_right = 563;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "na_right", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.na_right, SYNAPTICS_SYSCTL_NA_RIGHT,
+	    synaptics_sysctl, "I",
+	    "Right noisy area, where weight_previous_na is used instead "
+	    "of weight_previous");
+
+	/* hw.psm.synaptics.na_bottom. */
+	sc->syninfo.na_bottom = 1408;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "na_bottom", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.na_bottom, SYNAPTICS_SYSCTL_NA_BOTTOM,
+	    synaptics_sysctl, "I",
+	    "Bottom noisy area, where weight_previous_na is used instead "
+	    "of weight_previous");
+
+	/* hw.psm.synaptics.na_left. */
+	sc->syninfo.na_left = 1600;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "na_left", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.na_left, SYNAPTICS_SYSCTL_NA_LEFT,
+	    synaptics_sysctl, "I",
+	    "Left noisy area, where weight_previous_na is used instead "
+	    "of weight_previous");
+
+	/* hw.psm.synaptics.window_min. */
+	sc->syninfo.window_min = 4;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "window_min", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.window_min, SYNAPTICS_SYSCTL_WINDOW_MIN,
+	    synaptics_sysctl, "I",
+	    "Minimum window size to start an action");
+
+	/* hw.psm.synaptics.window_max. */
+	sc->syninfo.window_max = 10;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "window_max", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.window_max, SYNAPTICS_SYSCTL_WINDOW_MAX,
+	    synaptics_sysctl, "I",
+	    "Maximum window size");
+
+	/* hw.psm.synaptics.multiplicator. */
+	sc->syninfo.multiplicator = 10000;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "multiplicator", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.multiplicator, SYNAPTICS_SYSCTL_MULTIPLICATOR,
+	    synaptics_sysctl, "I",
+	    "Multiplicator to increase precision in averages and divisions");
+
+	/* hw.psm.synaptics.weight_current. */
+	sc->syninfo.weight_current = 3;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "weight_current", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.weight_current, SYNAPTICS_SYSCTL_WEIGHT_CURRENT,
+	    synaptics_sysctl, "I",
+	    "Weight of the current movement in the new average");
+
+	/* hw.psm.synaptics.weight_previous. */
+	sc->syninfo.weight_previous = 6;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "weight_previous", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.weight_previous, SYNAPTICS_SYSCTL_WEIGHT_PREVIOUS,
+	    synaptics_sysctl, "I",
+	    "Weight of the previous average");
+
+	/* hw.psm.synaptics.weight_previous_na. */
+	sc->syninfo.weight_previous_na = 20;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "weight_previous_na", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.weight_previous_na,
+	    SYNAPTICS_SYSCTL_WEIGHT_PREVIOUS_NA,
+	    synaptics_sysctl, "I",
+	    "Weight of the previous average (inside the noisy area)");
+
+	/* hw.psm.synaptics.weight_len_squared. */
+	sc->syninfo.weight_len_squared = 2000;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "weight_len_squared", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.weight_len_squared,
+	    SYNAPTICS_SYSCTL_WEIGHT_LEN_SQUARED,
+	    synaptics_sysctl, "I",
+	    "Length (squared) of segments where weight_previous "
+	    "starts to decrease");
+
+	/* hw.psm.synaptics.div_min. */
+	sc->syninfo.div_min = 9;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "div_min", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.div_min, SYNAPTICS_SYSCTL_DIV_MIN,
+	    synaptics_sysctl, "I",
+	    "Divisor for fast movements");
+
+	/* hw.psm.synaptics.div_max. */
+	sc->syninfo.div_max = 17;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "div_max", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.div_max, SYNAPTICS_SYSCTL_DIV_MAX,
+	    synaptics_sysctl, "I",
+	    "Divisor for slow movements");
+
+	/* hw.psm.synaptics.div_max_na. */
+	sc->syninfo.div_max_na = 30;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "div_max_na", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.div_max_na, SYNAPTICS_SYSCTL_DIV_MAX_NA,
+	    synaptics_sysctl, "I",
+	    "Divisor with slow movements (inside the noisy area)");
+
+	/* hw.psm.synaptics.div_len. */
+	sc->syninfo.div_len = 100;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "div_len", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.div_len, SYNAPTICS_SYSCTL_DIV_LEN,
+	    synaptics_sysctl, "I",
+	    "Length of segments where div_max starts to decrease");
+
+	/* hw.psm.synaptics.tap_max_delta. */
+	sc->syninfo.tap_max_delta = 80;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "tap_max_delta", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.tap_max_delta, SYNAPTICS_SYSCTL_TAP_MAX_DELTA,
+	    synaptics_sysctl, "I",
+	    "Length of segments above which a tap is ignored");
+
+	/* hw.psm.synaptics.tap_min_queue. */
+	sc->syninfo.tap_min_queue = 2;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "tap_min_queue", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.tap_min_queue, SYNAPTICS_SYSCTL_TAP_MIN_QUEUE,
+	    synaptics_sysctl, "I",
+	    "Number of packets required to consider a tap");
+
+	/* hw.psm.synaptics.taphold_timeout. */
+	sc->synaction.in_taphold = 0;
+	sc->syninfo.taphold_timeout = tap_timeout;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "taphold_timeout", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.taphold_timeout, SYNAPTICS_SYSCTL_TAPHOLD_TIMEOUT,
+	    synaptics_sysctl, "I",
+	    "Maximum elapsed time between two taps to consider a tap-hold "
+	    "action");
+
+	/* hw.psm.synaptics.vscroll_hor_area. */
+	sc->syninfo.vscroll_hor_area = 0; /* 1300 */
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "vscroll_hor_area", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.vscroll_hor_area, SYNAPTICS_SYSCTL_VSCROLL_HOR_AREA,
+	    synaptics_sysctl, "I",
+	    "Area reserved for horizontal virtual scrolling");
+
+	/* hw.psm.synaptics.vscroll_ver_area. */
+	sc->syninfo.vscroll_ver_area = -600;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "vscroll_ver_area", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.vscroll_ver_area, SYNAPTICS_SYSCTL_VSCROLL_VER_AREA,
+	    synaptics_sysctl, "I",
+	    "Area reserved for vertical virtual scrolling");
+
+	/* hw.psm.synaptics.vscroll_min_delta. */
+	sc->syninfo.vscroll_min_delta = 50;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "vscroll_min_delta", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.vscroll_min_delta,
+	    SYNAPTICS_SYSCTL_VSCROLL_MIN_DELTA,
+	    synaptics_sysctl, "I",
+	    "Minimum movement to consider virtual scrolling");
+
+	/* hw.psm.synaptics.vscroll_div_min. */
+	sc->syninfo.vscroll_div_min = 100;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "vscroll_div_min", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.vscroll_div_min, SYNAPTICS_SYSCTL_VSCROLL_DIV_MIN,
+	    synaptics_sysctl, "I",
+	    "Divisor for fast scrolling");
+
+	/* hw.psm.synaptics.vscroll_div_min. */
+	sc->syninfo.vscroll_div_max = 150;
+	SYSCTL_ADD_PROC(&sc->syninfo.sysctl_ctx,
+	    SYSCTL_CHILDREN(sc->syninfo.sysctl_tree), OID_AUTO,
+	    "vscroll_div_max", CTLTYPE_INT|CTLFLAG_RW|CTLFLAG_ANYBODY,
+	    &sc->syninfo.vscroll_div_max, SYNAPTICS_SYSCTL_VSCROLL_DIV_MAX,
+	    synaptics_sysctl, "I",
+	    "Divisor for slow scrolling");
+}
+
+static int
+enable_synaptics(struct psm_softc *sc)
+{
+	int status[3];
+	KBDC kbdc;
+
+	if (!synaptics_support)
+		return (FALSE);
+
+	kbdc = sc->kbdc;
+	VLOG(3, (LOG_DEBUG, "synaptics: BEGIN init\n"));
+	sc->hw.buttons = 3;
+	sc->squelch = 0;
+
+	/*
+	 * Just to be on the safe side: this avoids troubles with
+	 * following mouse_ext_command() when the previous command
+	 * was PSMC_SET_RESOLUTION. Set Scaling has no effect on
+	 * Synaptics Touchpad behaviour.
+	 */
+	set_mouse_scaling(kbdc, 1);
+
+	/* Identify the Touchpad version. */
+	if (mouse_ext_command(kbdc, 0) == 0)
+		return (FALSE);
+	if (get_mouse_status(kbdc, status, 0, 3) != 3)
+		return (FALSE);
+	if (status[1] != 0x47)
+		return (FALSE);
+
+	sc->synhw.infoMinor = status[0];
+	sc->synhw.infoMajor = status[2] & 0x0f;
+
+	if (verbose >= 2)
+		kprintf("Synaptics Touchpad v%d.%d\n", sc->synhw.infoMajor,
+		    sc->synhw.infoMinor);
+
+	if (sc->synhw.infoMajor < 4) {
+		kprintf("  Unsupported (pre-v4) Touchpad detected\n");
+		return (FALSE);
+	}
+
+	/* Get the Touchpad model information. */
+	if (mouse_ext_command(kbdc, 3) == 0)
+		return (FALSE);
+	if (get_mouse_status(kbdc, status, 0, 3) != 3)
+		return (FALSE);
+	if ((status[1] & 0x01) != 0) {
+		kprintf("  Failed to read model information\n");
+		return (FALSE);
+	}
+
+	sc->synhw.infoRot180   = (status[0] & 0x80) >> 7;
+	sc->synhw.infoPortrait = (status[0] & 0x40) >> 6;
+	sc->synhw.infoSensor   =  status[0] & 0x3f;
+	sc->synhw.infoHardware = (status[1] & 0xfe) >> 1;
+	sc->synhw.infoNewAbs   = (status[2] & 0x80) >> 7;
+	sc->synhw.capPen       = (status[2] & 0x40) >> 6;
+	sc->synhw.infoSimplC   = (status[2] & 0x20) >> 5;
+	sc->synhw.infoGeometry =  status[2] & 0x0f;
+
+	if (verbose >= 2) {
+		kprintf("  Model information:\n");
+		kprintf("   infoRot180: %d\n", sc->synhw.infoRot180);
+		kprintf("   infoPortrait: %d\n", sc->synhw.infoPortrait);
+		kprintf("   infoSensor: %d\n", sc->synhw.infoSensor);
+		kprintf("   infoHardware: %d\n", sc->synhw.infoHardware);
+		kprintf("   infoNewAbs: %d\n", sc->synhw.infoNewAbs);
+		kprintf("   capPen: %d\n", sc->synhw.capPen);
+		kprintf("   infoSimplC: %d\n", sc->synhw.infoSimplC);
+		kprintf("   infoGeometry: %d\n", sc->synhw.infoGeometry);
+	}
+
+	/* Read the extended capability bits. */
+	if (mouse_ext_command(kbdc, 2) == 0)
+		return (FALSE);
+	if (get_mouse_status(kbdc, status, 0, 3) != 3)
+		return (FALSE);
+	if (status[1] != 0x47) {
+		kprintf("  Failed to read extended capability bits\n");
+		return (FALSE);
+	}
+
+	/* Set the different capabilities when they exist. */
+	if ((status[0] & 0x80) >> 7) {
+		sc->synhw.capExtended    = (status[0] & 0x80) >> 7;
+		sc->synhw.capPassthrough = (status[2] & 0x80) >> 7;
+		sc->synhw.capSleep       = (status[2] & 0x10) >> 4;
+		sc->synhw.capFourButtons = (status[2] & 0x08) >> 3;
+		sc->synhw.capMultiFinger = (status[2] & 0x02) >> 1;
+		sc->synhw.capPalmDetect  = (status[2] & 0x01);
+
+		if (verbose >= 2) {
+			kprintf("  Extended capabilities:\n");
+			kprintf("   capExtended: %d\n", sc->synhw.capExtended);
+			kprintf("   capPassthrough: %d\n",
+			    sc->synhw.capPassthrough);
+			kprintf("   capSleep: %d\n", sc->synhw.capSleep);
+			kprintf("   capFourButtons: %d\n",
+			    sc->synhw.capFourButtons);
+			kprintf("   capMultiFinger: %d\n",
+			    sc->synhw.capMultiFinger);
+			kprintf("   capPalmDetect: %d\n",
+			    sc->synhw.capPalmDetect);
+		}
+
+		/*
+		 * If we have bits set in status[0] & 0x70, then we can load
+		 * more information about buttons using query 0x09.
+		 */
+		if (status[0] & 0x70) {
+			if (mouse_ext_command(kbdc, 0x09) == 0)
+				return (FALSE);
+			if (get_mouse_status(kbdc, status, 0, 3) != 3)
+				return (FALSE);
+			sc->hw.buttons = ((status[1] & 0xf0) >> 4) + 3;
+			if (verbose >= 2)
+				kprintf("  Additional Buttons: %d\n",
+				    sc->hw.buttons -3);
+		}
+	} else {
+		sc->synhw.capExtended = 0;
+
+		if (verbose >= 2)
+			kprintf("  No extended capabilities\n");
+	}
+
+	/*
+	 * Read the mode byte.
+	 *
+	 * XXX: Note the Synaptics documentation also defines the first
+	 * byte of the response to this query to be a constant 0x3b, this
+	 * does not appear to be true for Touchpads with guest devices.
+	 */
+	if (mouse_ext_command(kbdc, 1) == 0)
+		return (FALSE);
+	if (get_mouse_status(kbdc, status, 0, 3) != 3)
+		return (FALSE);
+	if (status[1] != 0x47) {
+		kprintf("  Failed to read mode byte\n");
+		return (FALSE);
+	}
+
+	/* Set the mode byte; request wmode where available. */
+	if (sc->synhw.capExtended)
+		mouse_ext_command(kbdc, 0xc1);
+	else
+		mouse_ext_command(kbdc, 0xc0);
+
+	/* "Commit" the Set Mode Byte command sent above. */
+	set_mouse_sampling_rate(kbdc, 20);
+
+	/*
+	 * Report the correct number of buttons
+	 *
+	 * XXX: I'm not sure this is used anywhere.
+	 */
+	if (sc->synhw.capExtended && sc->synhw.capFourButtons)
+		sc->hw.buttons = 4;
+
+	VLOG(3, (LOG_DEBUG, "synaptics: END init (%d buttons)\n",
+	    sc->hw.buttons));
+
+	/* Create sysctl tree. */
+	synaptics_sysctl_create_tree(sc);
+
+	/*
+	 * The touchpad will have to be reinitialized after
+	 * suspend/resume.
+	 */
+	sc->config |= PSM_CONFIG_HOOKRESUME | PSM_CONFIG_INITAFTERSUSPEND;
+
+	return (TRUE);
 }
 
 /* Interlink electronics VersaPad */
 static int
 enable_versapad(struct psm_softc *sc)
 {
-    KBDC kbdc = sc->kbdc;
-    int data[3];
-
-    set_mouse_resolution(kbdc, PSMD_RES_MEDIUM_HIGH); /* set res. 2 */
-    set_mouse_sampling_rate(kbdc, 100);		/* set rate 100 */
-    set_mouse_scaling(kbdc, 1);			/* set scale 1:1 */
-    set_mouse_scaling(kbdc, 1);			/* set scale 1:1 */
-    set_mouse_scaling(kbdc, 1);			/* set scale 1:1 */
-    set_mouse_scaling(kbdc, 1);			/* set scale 1:1 */
-    if (get_mouse_status(kbdc, data, 0, 3) < 3)	/* get status */
-	return FALSE;
-    if (data[2] != 0xa || data[1] != 0 )	/* rate == 0xa && res. == 0 */
-	return FALSE;
-    set_mouse_scaling(kbdc, 1);			/* set scale 1:1 */
-
-    sc->config |= PSM_CONFIG_HOOKRESUME | PSM_CONFIG_INITAFTERSUSPEND;
-
-    return TRUE;				/* PS/2 absolute mode */
+	KBDC kbdc = sc->kbdc;
+	int data[3];
+
+	set_mouse_resolution(kbdc, PSMD_RES_MEDIUM_HIGH); /* set res. 2 */
+	set_mouse_sampling_rate(kbdc, 100);		/* set rate 100 */
+	set_mouse_scaling(kbdc, 1);			/* set scale 1:1 */
+	set_mouse_scaling(kbdc, 1);			/* set scale 1:1 */
+	set_mouse_scaling(kbdc, 1);			/* set scale 1:1 */
+	set_mouse_scaling(kbdc, 1);			/* set scale 1:1 */
+	if (get_mouse_status(kbdc, data, 0, 3) < 3)	/* get status */
+		return (FALSE);
+	if (data[2] != 0xa || data[1] != 0 )	/* rate == 0xa && res. == 0 */
+		return (FALSE);
+	set_mouse_scaling(kbdc, 1);			/* set scale 1:1 */
+
+	sc->config |= PSM_CONFIG_HOOKRESUME | PSM_CONFIG_INITAFTERSUSPEND;
+
+	return (TRUE);				/* PS/2 absolute mode */
+}
+
+/*
+ * Return true if 'now' is earlier than (start + (secs.usecs)).
+ * Now may be NULL and the function will fetch the current time from
+ * getmicrouptime(), or a cached 'now' can be passed in.
+ * All values should be numbers derived from getmicrouptime().
+ */
+static int
+timeelapsed(start, secs, usecs, now)
+	const struct timeval *start, *now;
+	int secs, usecs;
+{
+	struct timeval snow, tv;
+
+	/* if there is no 'now' passed in, the get it as a convience. */
+	if (now == NULL) {
+		getmicrouptime(&snow);
+		now = &snow;
+	}
+
+	tv.tv_sec = secs;
+	tv.tv_usec = usecs;
+	timevaladd(&tv, start);
+	return (timevalcmp(&tv, now, <));
 }
 
 static int
 psmresume(device_t dev)
 {
-    struct psm_softc *sc = device_get_softc(dev);
-    int unit = device_get_unit(dev);
-    int err;
+	struct psm_softc *sc = device_get_softc(dev);
+	int unit = device_get_unit(dev);
+	int err;
 
-    if (verbose >= 2)
-        log(LOG_NOTICE, "psm%d: system resume hook called.\n", unit);
+	VLOG(2, (LOG_NOTICE, "psm%d: system resume hook called.\n", unit));
 
-    if (!(sc->config & PSM_CONFIG_HOOKRESUME))
-	return (0);
+	if (!(sc->config & PSM_CONFIG_HOOKRESUME))
+		return (0);
 
-    err = reinitialize(sc, sc->config & PSM_CONFIG_INITAFTERSUSPEND);
+	err = reinitialize(sc, sc->config & PSM_CONFIG_INITAFTERSUSPEND);
 
-    if ((sc->state & PSM_ASLP) && !(sc->state & PSM_VALID)) {
-	/* 
-	 * Release the blocked process; it must be notified that the device
-	 * cannot be accessed anymore.
-	 */
-        sc->state &= ~PSM_ASLP;
-        wakeup((caddr_t)sc);
-    }
+	if ((sc->state & PSM_ASLP) && !(sc->state & PSM_VALID)) {
+		/*
+		 * Release the blocked process; it must be notified that
+		 * the device cannot be accessed anymore.
+		 */
+		sc->state &= ~PSM_ASLP;
+		wakeup(sc);
+	}
 
-    if (verbose >= 2)
-        log(LOG_DEBUG, "psm%d: system resume hook exiting.\n", unit);
+	VLOG(2, (LOG_DEBUG, "psm%d: system resume hook exiting.\n", unit));
 
-    return (err);
+	return (err);
 }
 
 DRIVER_MODULE(psm, atkbdc, psm_driver, psm_devclass, 0, 0);
+
+
+#if 0
+/*
+ * This sucks up assignments from PNPBIOS and ACPI.
+ */
+
+/*
+ * When the PS/2 mouse device is reported by ACPI or PnP BIOS, it may
+ * appear BEFORE the AT keyboard controller.  As the PS/2 mouse device
+ * can be probed and attached only after the AT keyboard controller is
+ * attached, we shall quietly reserve the IRQ resource for later use.
+ * If the PS/2 mouse device is reported to us AFTER the keyboard controller,
+ * copy the IRQ resource to the PS/2 mouse device instance hanging
+ * under the keyboard controller, then probe and attach it.
+ */
+
+static	devclass_t			psmcpnp_devclass;
+
+static	device_probe_t			psmcpnp_probe;
+static	device_attach_t			psmcpnp_attach;
+
+static device_method_t psmcpnp_methods[] = {
+	DEVMETHOD(device_probe,		psmcpnp_probe),
+	DEVMETHOD(device_attach,	psmcpnp_attach),
+
+	{ 0, 0 }
+};
+
+static driver_t psmcpnp_driver = {
+	PSMCPNP_DRIVER_NAME,
+	psmcpnp_methods,
+	1,			/* no softc */
+};
+
+static struct isa_pnp_id psmcpnp_ids[] = {
+	{ 0x030fd041, "PS/2 mouse port" },		/* PNP0F03 */
+	{ 0x0e0fd041, "PS/2 mouse port" },		/* PNP0F0E */
+	{ 0x120fd041, "PS/2 mouse port" },		/* PNP0F12 */
+	{ 0x130fd041, "PS/2 mouse port" },		/* PNP0F13 */
+	{ 0x1303d041, "PS/2 port" },			/* PNP0313, XXX */
+	{ 0x02002e4f, "Dell PS/2 mouse port" },		/* Lat. X200, Dell */
+	{ 0x0002a906, "ALPS Glide Point" },		/* ALPS Glide Point */
+	{ 0x80374d24, "IBM PS/2 mouse port" },		/* IBM3780, ThinkPad */
+	{ 0x81374d24, "IBM PS/2 mouse port" },		/* IBM3781, ThinkPad */
+	{ 0x0190d94d, "SONY VAIO PS/2 mouse port"},     /* SNY9001, Vaio */
+	{ 0x0290d94d, "SONY VAIO PS/2 mouse port"},	/* SNY9002, Vaio */
+	{ 0x0390d94d, "SONY VAIO PS/2 mouse port"},	/* SNY9003, Vaio */
+	{ 0x0490d94d, "SONY VAIO PS/2 mouse port"},     /* SNY9004, Vaio */
+	{ 0 }
+};
+
+static int
+create_a_copy(device_t atkbdc, device_t me)
+{
+	device_t psm;
+	u_long irq;
+
+	/* find the PS/2 mouse device instance under the keyboard controller */
+	psm = device_find_child(atkbdc, PSM_DRIVER_NAME,
+	    device_get_unit(atkbdc));
+	if (psm == NULL)
+		return (ENXIO);
+	if (device_get_state(psm) != DS_NOTPRESENT)
+		return (0);
+
+	/* move our resource to the found device */
+	irq = bus_get_resource_start(me, SYS_RES_IRQ, 0);
+	bus_set_resource(psm, SYS_RES_IRQ, KBDC_RID_AUX, irq, 1);
+
+	/* ...then probe and attach it */
+	return (device_probe_and_attach(psm));
+}
+
+static int
+psmcpnp_probe(device_t dev)
+{
+	struct resource *res;
+	u_long irq;
+	int rid;
+
+	if (ISA_PNP_PROBE(device_get_parent(dev), dev, psmcpnp_ids))
+		return (ENXIO);
+
+	/*
+	 * The PnP BIOS and ACPI are supposed to assign an IRQ (12)
+	 * to the PS/2 mouse device node. But, some buggy PnP BIOS
+	 * declares the PS/2 mouse device node without an IRQ resource!
+	 * If this happens, we shall refer to device hints.
+	 * If we still don't find it there, use a hardcoded value... XXX
+	 */
+	rid = 0;
+	irq = bus_get_resource_start(dev, SYS_RES_IRQ, rid);
+	if (irq <= 0) {
+		if (resource_long_value(PSM_DRIVER_NAME,
+		    device_get_unit(dev),"irq", &irq) != 0)
+			irq = 12;	/* XXX */
+		device_printf(dev, "irq resource info is missing; "
+		    "assuming irq %ld\n", irq);
+		bus_set_resource(dev, SYS_RES_IRQ, rid, irq, 1);
+	}
+	res = bus_alloc_resource_any(dev, SYS_RES_IRQ, &rid, RF_SHAREABLE);
+	bus_release_resource(dev, SYS_RES_IRQ, rid, res);
+
+	/* keep quiet */
+	if (!bootverbose)
+		device_quiet(dev);
+
+	return ((res == NULL) ? ENXIO : 0);
+}
+
+static int
+psmcpnp_attach(device_t dev)
+{
+	device_t atkbdc;
+	int rid;
+
+	/* find the keyboard controller, which may be on acpi* or isa* bus */
+	atkbdc = devclass_get_device(devclass_find(ATKBDC_DRIVER_NAME),
+	    device_get_unit(dev));
+	if ((atkbdc != NULL) && (device_get_state(atkbdc) == DS_ATTACHED))
+		create_a_copy(atkbdc, dev);
+	else {
+		/*
+		 * If we don't have the AT keyboard controller yet,
+		 * just reserve the IRQ for later use...
+		 * (See psmidentify() above.)
+		 */
+		rid = 0;
+		bus_alloc_resource_any(dev, SYS_RES_IRQ, &rid, RF_SHAREABLE);
+	}
+
+	return (0);
+}
+
+DRIVER_MODULE(psmcpnp, isa, psmcpnp_driver, psmcpnp_devclass, 0, 0);
+DRIVER_MODULE(psmcpnp, acpi, psmcpnp_driver, psmcpnp_devclass, 0, 0);
+#endif
